#pragma once

#include <memory>

class AudioDevice;
using AudioDevicePtr = std::shared_ptr<AudioDevice>;

class AudioInterface
{
public:

    AudioInterface();

    static std::unique_ptr<AudioInterface> Create();

    void OpenDevice(AudioDevicePtr device);

    void Play(AudioDevicePtr device);
};

using AudioInterfaceUPtr = std::unique_ptr<AudioInterface>;