#pragma

#include <memory>

class Socket;
using SocketPtr = std::shared_ptr<Socket>;

class SocketInterface
{
public:

    SocketInterface();

    static std::unique_ptr<SocketInterface> Create();
    void CreateSocket(SocketPtr socket);
    void Listen(SocketPtr socket);
    void Run(SocketPtr socket);
};

using SocketInterfaceUPtr = std::unique_ptr<SocketInterface>;